<!DOCTYPE html>
<html lang="cs">
  <head>
    <meta charset='UTF-8'>
    <meta name="author" content="Benjamin Verner">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="styles.css">
    <title>
    Sudoku
    </title>
  </head>
  <body>
    <ul>
      <li class="menu"><a href="index.html">Úvod</a></li>
      <li class="menu"><a href="solver.html">SAT Solver</a></li>
      <li class="submenu">
        <a class="submenu-button">Konkrétní problémy</a>
        <div class="submenu-elements">
          <a href="pozorovani.html">Pozorování</a>
          <a href="sudoku.html">Sudoku</a>
          <a href="abc.html">Easy as ABC</a>
          <a href="logik.html">Logik</a>
          <a href="slitherlink.html">Slitherlink</a>
        </div>
      </li>
      <li class="menu"><a href="dokumentace.html">Technická dokumentace</a></li>
      <li class="menu"><a href="zaver.html">Závěr</a></li>
      <li class="menu"><a href="citace.html">Citace</a></li>
    </ul>
    <article>
      <h2 id="title">Sudoku</h2>
      <img src="sudoku_example.png" alt="Sudoku" class="image">
      <section>
        <h3>Popis problému</h3>
        <p>Zadáním pro Sudoku je mřížka typu NxN (nejčastěji 9x9) obsahující √N podmřížek typu √Nx√N. Jsou v ní rozmístěna čísla. Úkolem je doplnit ostatní čísla od 1 do N tak, aby v každém sloupci, řádku a podmřížce bylo každé číslo pouze jednou.</p>
      </section>
      <section>
        <h3>Pravidla</h3>
        <p>U Sudoku nadefinujeme N proměnných pro každou pozici - jednu pro každé číslo. Ty nám určují, zda se na daném místě číslo nachází.</p>
        <p>Pravidla jsou trojího typu. Musíme zaručit, že (i) na každé pozici je právě jedno čislo, že (ii) v každém řádku, sloupci a čtverci je pouze jedno číslo od každého druhu, a naposled, že (iii) na pozicích, která jsou ze zadání vyplněná, se nachází dané číslo.</p>
        <p>Pro pravidlo (i) by nám mohla stačit podmínka, že na ní je minimálně jedno číslo, jelikož nemožnost více čísel vyplývá z ostatních pravidel. Obecně ale platí, že čím více klauzulí vygenerujeme, tím dřív jsme schopni při prohledávání poznat, že daná cesta není řešení.</p>
        <p>Nejjednodušší pravidlo je pravidlo vyplněných pozic. Stačí vygenerovat klauzuli s jednou proměnnou, což bude dané číslo na dané pozici. Všechny klauzule musí být pravdivé, tudíž číslo se tam nutně nachází. Podobně triviální je i pravidlo nutnosti čísla na pozici. Jednoduše vytvoříme klauzuli všech proměnných dané pozice, čímž máme zaručeno, že alespoň jedno se tam musí nacházet, aby klauzule platila.</p>
        <p>Všechna ostatní pravidla se řeší identicky. Máme 1 číslo na N pozic (případně N čísel na 1 pozici v případě (i)), tedy N proměnných, ze kterých chceme, aby platila právě jedna. Klauzule se sestávají z dvouprvkových kombinací negací všech proměnných, tedy obecně ¬A ∨ ¬B. Tak máme danou proměnnou napárovanou ve dvojici se všemi ostatními. Pokud jí přiřadíme hodnotu 1, její negace nebude platit, a tudíž musí platit negace všech ostatních proměnných.</p>
      </section>
    </article>
  </body>
</html>
